<?php
if (!defined('__TYPECHO_ROOT_DIR__')) exit;

//define('__TYPECHO_DEBUG__', true); //使用插件出现问题时，可取消此行注释启用debug模式，将错误信息反馈给作者

/**
 * 完美复刻MbEditor的付费版，利用CodeMirror给你的后台模板编辑器增加高亮和行号以及匹配括号等功能
 * 
 * @package ThemeEditorPro
 * @author MoLeft
 * @version 1.0.0
 * @link http://www.moleft.cn
 */
class ThemeEditorPro_Plugin implements Typecho_Plugin_Interface
{
    /**
     * 激活插件方法,如果激活失败,直接抛出异常
     * 
     * @access public
     * @return void
     * @throws Typecho_Plugin_Exception
     */
    public static function activate()
    {
         Typecho_Plugin::factory('admin/theme-editor.php')->bottom = array('ThemeEditorPro_Plugin', 'footer');
    }
    
    /**
     * 禁用插件方法,如果禁用失败,直接抛出异常
     * 
     * @static
     * @access public
     * @return void
     * @throws Typecho_Plugin_Exception
     */
    public static function deactivate(){}
    
    /**
     * 获取插件配置面板
     * 
     * @access public
     * @param Typecho_Widget_Helper_Form $form 配置面板
     * @return void
     */
    public static function config(Typecho_Widget_Helper_Form $form){
    	 $res = new Typecho_Widget_Helper_Form_Element_Radio(
            'res' ,
            array(
                'bootcss' => _t('使用bootcss的cdn资源'),
                'local' => _t('使用本地的资源'),
            ),
            'local' ,
            _t('资源加载设置'),'设置需要加载的资源，建议使用cdn资源，如果不考虑加载速度可以使用本地资源。'
        );
        $form->addInput($res);
        $style = new Typecho_Widget_Helper_Form_Element_Select(
            'style' ,
            array(
                'default' => _t('默认样式'),
                            	'3024-day' => _t('3024-day'),
            	'3024-night' => _t('3024-night'),
            	'abcdef' => _t('abcdef'),
            	'ambiance' => _t('ambiance'),
            	'ayu-dark' => _t('ayu-dark'),
            	'ayu-mirage' => _t('ayu-mirage'),
            	'base16-dark' => _t('base16-dark'),
            	'base16-light' => _t('base16-light'),
            	'bespin' => _t('bespin'),
            	'blackboard' => _t('blackboard'),
            	'cobalt' => _t('cobalt'),
            	'colorforth' => _t('colorforth'),
            	'darcula' => _t('darcula'),
            	'dracula' => _t('dracula'),
            	'duotone-dark' => _t('duotone-dark'),
            	'duotone-light' => _t('duotone-light'),
            	'eclipse' => _t('eclipse'),
            	'elegant' => _t('elegant'),
            	'erlang-dark' => _t('erlang-dark'),
            	'gruvbox-dark' => _t('gruvbox-dark'),
            	'hopscotch' => _t('hopscotch'),
            	'icecoder' => _t('icecoder'),
            	'idea' => _t('idea'),
            	'isotope' => _t('isotope'),
            	'lesser-dark' => _t('lesser-dark'),
            	'liquibyte' => _t('liquibyte'),
            	'lucario' => _t('lucario'),
            	'material' => _t('material'),
            	'material-darker' => _t('material-darker'),
            	'material-palenight' => _t('material-palenight'),
            	'material-ocean' => _t('material-ocean'),
            	'mbo' => _t('mbo'),
            	'mdn-like' => _t('mdn-like'),
            	'midnight' => _t('midnight'),
            	'monokai' => _t('monokai'),
            	'moxer' => _t('moxer'),
            	'neat' => _t('neat'),
            	'neo' => _t('neo'),
            	'night' => _t('night'),
            	'nord' => _t('nord'),
            	'oceanic-next' => _t('oceanic-next'),
            	'panda-syntax' => _t('panda-syntax'),
            	'paraiso-dark' => _t('paraiso-dark'),
            	'paraiso-light' => _t('paraiso-light'),
            	'pastel-on-dark' => _t('pastel-on-dark'),
            	'railscasts' => _t('railscasts'),
            	'rubyblue' => _t('rubyblue'),
            	'seti' => _t('seti'),
            	'shadowfox' => _t('shadowfox'),
            	'solarizeddark' => _t('solarizeddark'),
            	'solarizedlight' => _t('solarizedlight'),
            	'the-matrix' => _t('the-matrix'),
            	'tomorrow-night-bright' => _t('tomorrow-night-bright'),
            	'tomorrow-night-eighties' => _t('tomorrow-night-eighties'),
            	'ttcn' => _t('ttcn'),
            	'twilight' => _t('twilight'),
            	'vibrant-ink' => _t('vibrant-ink'),
            	'xq-dark' => _t('xq-dark'),
            	'xq-light' => _t('xq-light'),
            	'yeti' => _t('yeti'),
            	'yonce' => _t('yonce'),
            	'zenburn' => _t('zenburn'),
            ),
            'default' ,
            _t('高亮主题设置'),'设置高亮主题的样式，可以根据自己的喜好来选择。'
        );
        $form->addInput($style);
        
        try {
        	$options = Typecho_Widget::widget('Widget_Options')->plugin('ThemeEditorPro');
        } catch (Exception $e) {
        	$options->res = 'local';
        	$options->style = 'default';
        }
		if($options->res == 'bootcss'){
			$url = 'https://cdn.bootcss.com/codemirror/5.52.2/';
			$css = $url.'codemirror.css';
			$theme_path = $url.'theme/';
			$js_file = array(
				'codemirror' => $url.'codemirror.js',
				'xml' => $url.'mode/xml/xml.js',
				'javascript' => $url.'addon/hint/javascript-hint.js',
				'css' => $url.'mode/css/css.js',
				'clike' => $url.'mode/clike/clike.js',
				'php' => $url.'mode/php/php.js',
				'htmlmixed' => $url.'mode/htmlmixed/htmlmixed.js',
				'matchbrackets' => $url.'addon/edit/matchbrackets.min.js'
			);
		}else{
			$url = Helper::options()->pluginUrl.'/ThemeEditorPro/static/js/';
			$css = Helper::options()->pluginUrl.'/ThemeEditorPro/static/css/codemirror.css';
			$theme_path = Helper::options()->pluginUrl.'/ThemeEditorPro/static/theme/';
			$js_file = array(
				'codemirror' => $url.'codemirror.js',
				'xml' => $url.'xml.js',
				'javascript' => $url.'javascript-hint.js',
				'css' => $url.'css.js',
				'clike' => $url.'clike.js',
				'php' => $url.'php.js',
				'htmlmixed' => $url.'htmlmixed.js',
				'matchbrackets' => $url.'matchbrackets.min.js'
			);
		}
		if(!empty($options->style) && $options->style != 'default' && file_exists(dirname(__FILE__).'/static/theme/'.$options->style.'.css')){
			$theme = 'this.CodeMirrorEditor.setOption("theme", "'.$options->style.'");';
			$include = '<link href="'.$theme_path.$options->style.'.css" rel="stylesheet">';
		}else{
			$theme = "";
			$include = "";
		}
?>
<h3>主题样式预览</h3>
<textarea class="CodeMirror" id="code" name="code">&lt;?php
/**
 * MoLeft高仿泽泽社长MbEditor付费版
 */
class MoLeft
{
	private moleft;
	public function set_moleft($var){
		$this->moleft = $var;
	}
	
	public function get_moleft(){
		return isset($this->moleft)?$this->moleft:false;
	}
}
?&gt;</textarea>
<link href="<?=$css;?>" rel="stylesheet">
<?=$include;?>
<style>.CodeMirror {height: 300px;}</style>
<?php
foreach ($js_file as $k => $v){
?>
<script src="<?=$v;?>"></script>
<?php
}
?>
<script>
let myTextarea = document.getElementById("code");
this.CodeMirrorEditor = CodeMirror.fromTextArea(myTextarea,{mode: "application/x-httpd-php",lineNumbers: true,indentUnit: 4,styleActiveLine: true, matchBrackets: true,lineWrapping: true});
<?=$theme;?>
</script>
		<?php
    }
    
    /**
     * 个人用户的配置面板
     * 
     * @access public
     * @param Typecho_Widget_Helper_Form $form
     * @return void
     */
    public static function personalConfig(Typecho_Widget_Helper_Form $form){}
    
    /**
     * 插件实现方法
     * 
     * @access public
     * @return void
     */
    public static function footer(){
		$options = Typecho_Widget::widget('Widget_Options')->plugin('ThemeEditorPro');
		if($options->res == 'bootcss'){
			$url = 'https://cdn.bootcss.com/codemirror/5.52.2/';
			$css = $url.'codemirror.css';
			$theme_path = $url.'theme/';
			$js_file = array(
				'codemirror' => $url.'codemirror.js',
				'xml' => $url.'mode/xml/xml.js',
				'javascript' => $url.'addon/hint/javascript-hint.js',
				'css' => $url.'mode/css/css.js',
				'clike' => $url.'mode/clike/clike.js',
				'php' => $url.'mode/php/php.js',
				'htmlmixed' => $url.'mode/htmlmixed/htmlmixed.js',
				'matchbrackets' => $url.'addon/edit/matchbrackets.min.js'
			);
		}else{
			$url = Helper::options()->pluginUrl.'/ThemeEditorPro/static/js/';
			$css = Helper::options()->pluginUrl.'/ThemeEditorPro/static/css/codemirror.css';
			$theme_path = Helper::options()->pluginUrl.'/ThemeEditorPro/static/theme/';
			$js_file = array(
				'codemirror' => $url.'codemirror.js',
				'xml' => $url.'xml.js',
				'javascript' => $url.'javascript-hint.js',
				'css' => $url.'css.js',
				'clike' => $url.'clike.js',
				'php' => $url.'php.js',
				'htmlmixed' => $url.'htmlmixed.js',
				'matchbrackets' => $url.'matchbrackets.min.js'
			);
		}
		if(!empty($options->style) && $options->style != 'default' && file_exists(dirname(__FILE__).'/static/theme/'.$options->style.'.css')){
			$theme = 'this.CodeMirrorEditor.setOption("theme", "'.$options->style.'");';
			$include = '<link href="'.$theme_path.$options->style.'.css" rel="stylesheet">';
		}else{
			$theme = "";
			$include = "";
		}
?>      
<link href="<?=$css;?>" rel="stylesheet">
<?=$include;?>
<style>.CodeMirror {height: 500px;}</style>
<?php
foreach ($js_file as $k => $v){
?>
<script src="<?=$v;?>"></script>
<?php
}
?>
<script>
let myTextarea = document.getElementById("content");
this.CodeMirrorEditor = CodeMirror.fromTextArea(myTextarea,{mode: "application/x-httpd-php",lineNumbers: true,indentUnit: 4,styleActiveLine: true, matchBrackets: true,lineWrapping: true});
<?=$theme;?>
</script>
<?php
}
}